package com.ruoyi.project.sems.service.impl;

import java.io.IOException;
import java.time.LocalDate;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.framework.config.RuoYiConfig;
import com.ruoyi.project.common.domain.TCommonfile;
import com.ruoyi.project.common.mapper.TCommonfileMapper;
import com.ruoyi.project.sems.domain.DevData;
import com.ruoyi.project.sems.his.domain.TSpechiDt;
import org.springframework.stereotype.Service;
import com.ruoyi.project.sems.mapper.TSpecdevDtMapper;
import com.ruoyi.project.sems.domain.TSpecdevDt;
import com.ruoyi.project.sems.service.ITSpecdevDtService;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;

/**
 * 特种设备电梯台账Service业务层处理
 *
 * @author ruoyi
 * @date 2021-07-26
 */
@Service("tSpecdevDtService")
public class TSpecdevDtServiceImpl extends ServiceImpl<TSpecdevDtMapper, TSpecdevDt> implements ITSpecdevDtService
{
    @Resource
    private TSpecdevDtMapper tSpecdevDtMapper;
    @Resource
    private TCommonfileMapper tCommonfileMapper;
    /**
     * 查询特种设备电梯台账
     *
     * @param id 特种设备电梯台账ID
     * @return 特种设备电梯台账
     */
    @Override
    public TSpecdevDt selectTSpecdevDtById(Long id)
    {
        return tSpecdevDtMapper.selectTSpecdevDtById(id);
    }

    /**
     * 查询特种设备电梯台账列表
     *
     * @param tSpecdevDt 特种设备电梯台账
     * @return 特种设备电梯台账
     */
    @Override
    public List<TSpecdevDt> selectTSpecdevDtList(TSpecdevDt tSpecdevDt)
    {
        return tSpecdevDtMapper.selectTSpecdevDtList(tSpecdevDt);
    }

    @Override
    public List<TSpecdevDt> selectTSpecdevDtListByYear(TSpecdevDt tSpecdevDt) {
        return tSpecdevDtMapper.selectTSpecdevDtListByYear(tSpecdevDt);
    }

    /**
     * 新增特种设备电梯台账
     *
     * @param tSpecdevDt 特种设备电梯台账
     * @return 结果
     */
    @Override
    public int insertTSpecdevDt(TSpecdevDt tSpecdevDt)
    {
        return tSpecdevDtMapper.insertTSpecdevDt(tSpecdevDt);
    }

    /**
     * 修改特种设备电梯台账
     *
     * @param tSpecdevDt 特种设备电梯台账
     * @return 结果
     */
    @Override
    public int updateTSpecdevDt(TSpecdevDt tSpecdevDt)
    {
        return tSpecdevDtMapper.updateTSpecdevDt(tSpecdevDt);
    }

    /**
     * 批量删除特种设备电梯台账
     *
     * @param ids 需要删除的特种设备电梯台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevDtByIds(Long[] ids)
    {
        return tSpecdevDtMapper.deleteTSpecdevDtByIds(ids);
    }

    /**
     * 删除特种设备电梯台账信息
     *
     * @param id 特种设备电梯台账ID
     * @return 结果
     */
    @Override
    public int deleteTSpecdevDtById(Long id)
    {
        return tSpecdevDtMapper.deleteTSpecdevDtById(id);
    }

    @Override
    public List<DevData> otherDevCount(Map<String, Object> params) {
        return tSpecdevDtMapper.otherDevCount(params);
    }

    @Override
    public int updateTSpecdevDtByHi(TSpechiDt hientity) {
        return tSpecdevDtMapper.updateTSpecdevDtByHi(hientity);
    }

    @Override
    public void duplicateTSpecdevDt() {
        tSpecdevDtMapper.duplicateTSpecdevDt();
    }

    @Override
    @Transactional
    public int importFiles(List<MultipartFile> files, String plantCode, String fileType , String userId) throws Exception {
        for (MultipartFile file : files) {
            if (!file.isEmpty()) {
                String input = file.getOriginalFilename();
                int index = input.indexOf('_');
                String weiHao = (index != -1) ? input.substring(0, index) : input;
                System.out.println(weiHao); // 输出: 位号
                TSpecdevDt param = new TSpecdevDt();
                param.setRegno(weiHao);
                param.setPlantCode(plantCode);
                List<TSpecdevDt> list = tSpecdevDtMapper.selectTSpecdevDtListByDevNo(param);
                if (list.size() > 0) {
                    for (TSpecdevDt t: list
                    ) {
                        Long id = t.getId();
                        // 获取当前日期
                        LocalDate currentDate = LocalDate.now();
                        // 获取年份
                        int year = currentDate.getYear();
                        String dir = "/sems-dt-" + fileType + "/" + year;
                        String url = null;
                        try {
                            url = FileUploadUtils.upload(RuoYiConfig.getFilePath(dir), file);
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        long size = file.getSize()/1024;
                        TCommonfile tCommonfile = new TCommonfile();
                        tCommonfile.setFileUrl(url);
                        tCommonfile.setFileName(file.getOriginalFilename());
                        tCommonfile.setCreaterCode(userId);
                        tCommonfile.setpId(id);
                        tCommonfile.setpType("sems-dt-"+fileType);
                        tCommonfile.setFileSize(String.valueOf(size));
                        tCommonfileMapper.insertTCommonfile(tCommonfile);
                    }
                }else {
                    throw new Exception( StringUtils.format(input +":无法找到对应设备"));
                }
            }
        }
        return 1;
    }
}
